<template lang="pug">
b-card( title="Создать рассылку" )
	form.form( @submit.prevent='submit' )
		.block.is-flex.is-align-items-center.is-justify-content-flex-start
			p 
				|Группа рассылки:&nbsp;
				span.has-text-weight-bold {{ group ? group.name : "" }}
			.button.is-small.is-link.is-light.ml-2( @click='activeSelector = true' ) Изменить
		b-field( label="Текст рассылки" )
			.block( v-if='content' )
				.columns.is-flex( v-if='content.images && content.images.length' )
					.column.is-narrow( v-for='(file, i) in content.images' :key='i' )
						b-file( :file='file' type="image" @remove='content.images.splice(i, 1)' )

				.columns.is-flex( v-if='content.files && content.files.length' )
					.column.is-narrow( v-for='(file, i) in content.files' :key='i' )
						b-file( :file='file' type="file" @remove='content.files.splice(i, 1)' )
			WYSIWYG( v-model='content' @submit='submit' )
		b-field
			button.button.is-primary( :class='{ "is-loading": pending }' ) Создать
transition( name="fade" )
	group-select( :active='activeSelector' @select='handleSelect' @close='activeSelector = false' )
</template>

<script setup>
import BFile from "@/components/chat/File.vue"
import BField from "@/components/form/Field.vue"
import BInput from "@/components/form/Input.vue"
import WYSIWYG from "@/components/chat/Input.vue"
import GroupSelect from '@/components/group/GroupSelect.vue'

import { computed, ref, watch } from "vue"

import { useCampaginStore } from "@/stores/campagin"
import { useToast } from "vue-toastification"
import { useRouter } from "vue-router"

const $router = useRouter()
const cs = useCampaginStore()
const toast = useToast()

const group = ref(null)
const content = ref(null)
const activeSelector = ref(false)
const pending = ref(false)

// const message = computed(() => content.value?.data)

watch(group, () => activeSelector.value = false)

const handleSelect = e => group.value = e

const submit = async () => {
	if (pending.value) return
	if (!group.value || !content.value?.data?.replace(/<p>/g, "").replace(/<\/p>/g, "")) return toast.warning("Группа и текст рассылки обязательны для заполнения")

	pending.value = true
	try {
		const id = await cs.createCampagin({ message: content.value, group: group.value.id })
		$router.push({ name: "Campagin", params: { id } })
	} catch(err) {
		console.error(err)
	}
	pending.value = false
}
</script>